{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit DDOCommonTests;

{$I DDObjectsTests.inc}

interface

uses
  SysUtils, TestFramework, DDOTestExtensions;

type
  TDDOCommonTests = class(TTestCase)
  published
    procedure GUITest;
    procedure CompressionTest;
  end;

implementation

uses
  Windows, DDOBase, DDOTestForm;

const
  CTestCount = 10;
  CTestLength = 500;

//----------------------------------------------------------------------------
//2006-12-15 00:09 N,SM:

procedure TDDOCommonTests.GUITest;
begin
  with TTestForm.Create(nil) do
  try
    CheckTrue(DDOListener1.Active);
    CheckTrue(DDOListener1.UseSSL);
    CheckTrue(DDORequester1.UseSSL);
    CheckTrue(DDOBroker1.Active);
    CheckTrue(DDONameServer1.Active);
    CheckTrue(DDODataGrid1.Active);
    CheckEquals(6666, DDOListener1.Port);
    CheckEquals(6667, DDOBroker1.Port);
    CheckEquals(6668, DDONameServer1.Port);
    CheckEquals(3, DDODataGrid1.DataLines.Count);
  finally
    Free;
  end;
end;

//----------------------------------------------------------------------------
//2006-12-15 00:09 N,SM:

procedure TDDOCommonTests.CompressionTest;
var
  lUncompressed,
  lDataString: String;
  i, j: Integer;
begin
  for i := 1 to CTestCount -1 do
  begin
    lUncompressed := EmptyStr;
    for j := 0 to CTestCount * CTestLength -1 do
      lUncompressed := lUncompressed + Char(Random(200) +32);
    lDataString := lUncompressed;
    Compress(lDataString);
    CheckTrue(Length(lDataString) < Length(lUncompressed));
    CheckTrue(lDataString[1] = '#');
    Uncompress(lDataString);
    CheckEqualsString(lUncompressed, lDataString);
  end;
end;

initialization
  TestFramework.RegisterTest('DDOCommonTests',
    TDDOCommonTests.Suite);

end.
