{*****************************************************************************}
{  DDObjects                                            www.delphi-online.at  }
{  Copyright (C) 2006 Stefan Meisner, stefan.meisner@gmx.net                  }
{  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    }
{  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABI-    }
{  LITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY  }
{  RIGHTS. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR   }
{  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   }
{  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFT-    }
{  WARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         }
{*****************************************************************************}

unit uServerMainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, Spin, DDOServer, DDODocument, ComCtrls,
  ExtCtrls, uServerBaseForm, DDOBase, DDODataGrid, DDOProgressBar;

type
  TServerMainForm = class(TServerBaseForm)
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
  end;

var
  ServerMainForm: TServerMainForm;

implementation

{$R *.dfm}

uses
  uDemoClass_Stub;

type
  TDemoClass = class(TDemoClass_Stub)
  private
    FQuotes: TStrings;
  public
    procedure GetQuote(out Quote: String); override;
    procedure GetTime(out DateTime: TDateTime); override;
    procedure GetVarParam(var AString: String); override;
    procedure Initialize; override;
    destructor Destroy; override;
  end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TDemoClass.Initialize;
begin
  inherited;
  FQuotes := TStringList.Create;
  FQuotes.LoadFromFile('Quotes.txt');
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

destructor TDemoClass.Destroy;
begin
  FreeAndNil(FQuotes);
  inherited;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TDemoClass.GetQuote(out Quote: String);
begin
  // due to +1 an exception will be raised from time to time
  // this is intentional to show how DDObjects handles exceptions
  Quote := FQuotes[Random(FQuotes.Count +1)];
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TDemoClass.GetTime(out DateTime: TDateTime);
begin
  DateTime := Now;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TDemoClass.GetVarParam(var AString: String);
begin
  AString := AString + AString;
end;

//----------------------------------------------------------------------------
//2006-13-02 N,SM:

procedure TServerMainForm.FormCreate(Sender: TObject);
begin
  inherited;
  DDOListener1.RegisterClass(TDemoClass);
  UpdateGUI;
end;

end.
